library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

library work;
use work.definitions.all;
--use work.numeric_signed.all;	-- Inneholder divisjon av std_logic_vector() Lagt til.
use work.numeric_unsigned.all;
------------------------------------------------------------------------------- 
entity DIV_UNIT is
	port (
		CLK		: in  STD_LOGIC;
		DIVIDEND	: in  STD_LOGIC_VECTOR (data_width*2 - 1 downto 0);
		DIVISOR		: in  STD_LOGIC_VECTOR (data_width - 1 downto 0);
		DIV_RESULT	: out STD_LOGIC_VECTOR (data_width*2 downto 0)
	);
end DIV_UNIT;
-------------------------------------------------------------------------------

architecture Behavioral of DIV_UNIT is

	signal A_REG: std_logic_vector(data_width*2 - 1 downto 0);
	signal B_REG: std_logic_vector(data_width - 1 downto 0);
	signal RD_REG: std_logic_vector(data_width*2 downto 0);

begin

division : process(CLK)

begin

	if CLK'event and CLK = '1' then
		A_REG <= DIVIDEND;
		B_REG <= DIVISOR;

		RD_REG(26) <= '0';
		RD_REG(25 downto 0) <= "/"(A_REG, B_REG);
	end if;

end process;

DIV_RESULT <= RD_REG;


end Behavioral;
