


-- Filename          : tb_tmp.vhd
-- Modelname         : TB_COMMUTATION_MUX_INTERFACECOMMUTATION_MUX_INTERFACE
-- Title             :
-- Purpose           :
-- Author(s)         : root
-- Comment           :
-- Assumptions       :
-- Limitations       :
-- Known errors      :
-- Specification ref :
-- ------------------------------------------------------------------------
-- Modification history:
-- ------------------------------------------------------------------------
-- Version  | Author | Date       | Changes made
-- ------------------------------------------------------------------------
-- 1.0      | root | 09.06.2006 | inital version


library IEEE, WORK;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use WORK.definitions.all;

entity TB_COMMUTATION_MUX_INTERFACE is	--COMMUTATION_MUX_INTERFACE is
end TB_COMMUTATION_MUX_INTERFACE;--COMMUTATION_MUX_INTERFACE;

architecture BEH of TB_COMMUTATION_MUX_INTERFACE is		--COMMUTATION_MUX_INTERFACE is

   component COMMUTATION_MUX_INTERFACE	--COMMUTATION_MUX_INTERFACE
      port(CLK               : in std_logic ;
           RESET             : in std_logic ;
           COMMUTATION_IN    : in std_logic_vector ( 5 downto 0 );
           PWM_IN            : in std_logic ;
           COMMUTATION_OUT   : out std_logic_vector ( 5 downto 0 ) );

   end component;


   constant PERIOD : time := 30 ns;
   
   constant PWM_PERIOD : time := 100 us;
   
   constant motor_delay : time := 1 ms;

   signal W_CLK               : std_logic  := '0';
   signal W_RESET             : std_logic ;
   signal W_COMMUTATION_IN    : std_logic_vector ( 5 downto 0 );
   signal W_PWM_IN            : std_logic := '0';
   signal W_COMMUTATION_OUT   : std_logic_vector ( 5 downto 0 ) ;
   --signal W_PWM_CLK	      : std_logic := '0';

begin

   DUT : COMMUTATION_MUX_INTERFACE			--COMMUTATION_MUX_INTERFACE
      port map(CLK               => W_CLK,
               RESET             => W_RESET,
               COMMUTATION_IN    => W_COMMUTATION_IN,
               PWM_IN            => W_PWM_IN,
               COMMUTATION_OUT   => W_COMMUTATION_OUT);

   W_CLK <= not W_CLK after PERIOD/2;
   
   W_PWM_IN <= not W_PWM_IN after PWM_PERIOD/2;

   STIMULI : process
   begin
      W_RESET             <= '0';
      W_COMMUTATION_IN    <= (others => '0');
      --W_PWM_IN            <= '1';
      
	while (true) loop
		
		W_COMMUTATION_IN <= "010100";	--"001100";
		wait for motor_delay;		--100 ns;
		
		W_COMMUTATION_IN <= "001100";	--"010001";
		wait for motor_delay;--100 ns;

		W_COMMUTATION_IN <= "001010";		--"010100";
		wait for motor_delay;--100 ns;

		W_COMMUTATION_IN <= "100010";		--"100010";
		wait for motor_delay;--100 ns;

		W_COMMUTATION_IN <= "100001";		--"001010";
		wait for motor_delay;--100 ns;

		W_COMMUTATION_IN <= "010001";		--"100001";
		wait for motor_delay;--100 ns;
		
	end loop;

      --wait for PERIOD;
      wait;
   end process STIMULI;

end BEH;

--configuration CFG_TB_COMMUTATION_MUX_INTERFACE of TB_COMMUTATION_MUX_INTERFACE is
--   for BEH
--   end for;
--end CFG_TB_COMMUTATION_MUX_INTERFACE;