-- Filename          : tb_tmp.vhd
-- Modelname         : TB_DIV_UNIT
-- Title             :
-- Purpose           :
-- Author(s)         : root
-- Comment           :
-- Assumptions       :
-- Limitations       :
-- Known errors      :
-- Specification ref :
-- ------------------------------------------------------------------------
-- Modification history:
-- ------------------------------------------------------------------------
-- Version  | Author | Date       | Changes made
-- ------------------------------------------------------------------------
-- 1.0      | root | 20.06.2006 | inital version


library IEEE, WORK;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use WORK.definitions.all;

entity TB_DIV_UNIT is
end TB_DIV_UNIT;

architecture BEH of TB_DIV_UNIT is

   component DIV_UNIT
      port(CLK          : in std_logic ;
           DIVIDEND     : in STD_LOGIC_VECTOR ( data_width*2 - 1 downto 0 );
           DIVISOR      : in STD_LOGIC_VECTOR ( data_width - 1 downto 0 );
           DIV_RESULT   : out STD_LOGIC_VECTOR ( data_width*2 downto 0 ) );

   end component;


   constant PERIOD : time := 10 ns;
   
   --constant data_width 	: integer := 5;

	signal W_CLK          : std_logic  := '1';
	signal W_DIVIDEND     : STD_LOGIC_VECTOR ( data_width*2 - 1 downto 0 );
	signal W_DIVISOR      : STD_LOGIC_VECTOR ( data_width - 1 downto 0 );
	signal W_DIV_RESULT   : STD_LOGIC_VECTOR ( data_width*2 downto 0 ) ;
	
	alias divide_by_zero 	is w_div_result(data_width*2);
	alias heltall		is w_div_result(data_width*2 -1 downto data_width);
	alias rest		is w_div_result(data_width -1 downto 0);

	signal div_heltall	: std_logic_vector(data_width-1 downto 0);
	signal div_rest		: std_logic_vector(data_width-1 downto 0);

begin

-- ********************************
DUT : DIV_UNIT
port map(CLK          => W_CLK,
	DIVIDEND     => W_DIVIDEND,
	DIVISOR      => W_DIVISOR,
	DIV_RESULT   => W_DIV_RESULT);
-- ********************************

W_CLK <= not W_CLK after PERIOD/2;

-- ********************************
signaler : process(w_div_result)
begin
	div_heltall 	<= heltall;
	div_rest	<= rest;
end process;
-- ********************************


-- *************************************************************
STIMULI : process

begin

	while (true) loop
	
--	wait for PERIOD;
--	w_dividend	<= (others => '0');
--	w_divisor	<= (others => '0');
--	wait for period;

	wait for period;
	w_dividend		<= (others => '0');
	w_dividend(6 downto 0)	<= "1100100";
	w_divisor		<= (others => '0');
	w_divisor(1 downto 0)	<= "11";
	wait for period*3;

	wait for period;
	w_dividend		<= (others => '0');
	w_dividend(11 downto 0)	<= "110010101101";	--3245
	w_divisor		<= (others => '0');
	w_divisor(7 downto 0)	<= "11101101";		--237
	
	wait for period;
	w_dividend		<= (others => '0');
	w_dividend(17 downto 0)	<= "101000000010100000";--164*1000 (Rest)
	w_divisor		<= (others => '0');
	w_divisor(7 downto 0)	<= "11101101";		--237
	
	wait for period;
	w_dividend		<= (others => '0');
	w_dividend(17 downto 0)	<= "111000111000101000";--233*1000
	w_divisor		<= (others => '0');
	w_divisor(7 downto 0)	<= "11101101";		--237


      
      
      end loop;
      
      wait;
   end process STIMULI;

end BEH;

--configuration CFG_TB_DIV_UNIT of TB_DIV_UNIT is
--   for BEH
--   end for;
--end CFG_TB_DIV_UNIT;