library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.VITAL_timing.all;

--library AT40K;
--use AT40K.VCOMPONENTS.all;

-- ******************* --
entity post_test_bench is
end post_test_bench;
-- ******************* --

-- ************************************************************************************ --
architecture arch_test_bench of post_test_bench is

component pwm_fpga
	port (
		clock : in STD_LOGIC := '0';
		reset : in STD_LOGIC := '0';
		Data_value : in STD_LOGIC_VECTOR(7 downto 0) := "00000000";
		pwm : out STD_LOGIC
	);
end component;

signal sig_pwm		: STD_LOGIC;
signal sig_reset	: STD_LOGIC;
signal sig_Data_value	: STD_LOGIC_VECTOR(7 downto 0);
signal sig_clock	: STD_LOGIC;
signal one 		: STD_LOGIC := '1';
signal zero 		: STD_LOGIC := '0';

shared variable ENDSIM	: boolean :=false;
constant clk_period	: TIME :=200 ns;

BEGIN

clk_gen: process
begin
	if ENDSIM = FALSE THEN
		sig_clock <= '1';
		wait for clk_period/2; sig_clock <= '0';
		wait for clk_period/2; else
		wait;
	end if;
end process;


inst_pwm_fpga : pwm_fpga

port map (
	clock 	=> sig_clock,
	reset 	=> sig_reset,
	Data_value => sig_Data_value, pwm => sig_pwm
);


stimulus_process: PROCESS
BEGIN
	sig_reset <= '1';
	wait for 100 ns;
	sig_reset 	<= '0';
	sig_data_value	<= "00111111"; wait for 1 ms;
	sig_data_value	<= "01000000"; wait for 1 ms;
	sig_data_value	<= "01111111"; wait for 1 ms;
	sig_data_value	<= "10000000"; wait for 1 ms;
	sig_data_value	<= "11000000"; wait for 1 ms;
	sig_data_value	<= "11100000"; wait for 1 ms;
	
	sig_data_value	<= "00000000"; wait for 1 ms;
	sig_data_value	<= "00000001"; wait for 1 ms;
	sig_data_value	<= "01111111"; wait for 1 ms;
	sig_data_value	<= "11111110"; wait for 1 ms;
	sig_data_value	<= "11111111"; wait for 1 ms;
	sig_data_value	<= "00000000"; wait for 1 ms;

--	sig_data_value	<= "11000000"; wait for 50 us;
--	sig_data_value 	<= "10000000"; wait for 50 us;
--	sig_data_value 	<= "01000000"; wait for 50 us;
--	sig_data_value 	<= "10000000";
	wait;
END PROCESS stimulus_process;

end arch_test_bench;
-- ************************************************************************************ --